#include <QDateTime>
#include <QFile>
#include <QMessageBox>
#include <QTextStream>

#include "Dictate2.h"

extern Player g_voice; // Only to be able to stop the sound

Dictate2::Dictate2(QWidget *parent) : CenterFrame(parent) {
   lo=new QVBoxLayout;
   loButtons=new QHBoxLayout;
   bHasTimedOut=false;

   line1=new QHBoxLayout;
   line2=new QHBoxLayout;
   line3=new QHBoxLayout;
   line4=new QHBoxLayout;
   line5=new QHBoxLayout;
   line6=new QHBoxLayout;
   line7=new QHBoxLayout;
   line8=new QHBoxLayout;
   line9=new QHBoxLayout;
   line10=new QHBoxLayout;
   line11=new QHBoxLayout;
   line12=new QHBoxLayout;
   line13=new QHBoxLayout;
   line14=new QHBoxLayout;
   line15=new QHBoxLayout;
   line16=new QHBoxLayout;
   line17=new QHBoxLayout;
   line18=new QHBoxLayout;
   line19=new QHBoxLayout;
   line20=new QHBoxLayout;
   line21=new QHBoxLayout;
   line22=new QHBoxLayout;
   line23=new QHBoxLayout;
   line24=new QHBoxLayout;
   line25=new QHBoxLayout;
   line26=new QHBoxLayout;
   line27=new QHBoxLayout;
   line28=new QHBoxLayout;
   line29=new QHBoxLayout;
   line30=new QHBoxLayout;
   line31=new QHBoxLayout;
   line32=new QHBoxLayout;
   line33=new QHBoxLayout;

   laHeadLine=new QLabel(tr("<html><b>Diktat 2</b><br>"));
   laHeadLine->setFont(foHeadLine);

   laTime=new QLabel(tr("<b>Du har 30 minutter til diktaten</b><hr></html>"));
   laTime->setFont(foTime);

   // Line 1:
   la1=new QLabel(tr("Vi"));
   dw1=new DictateWord(this,tr("ankom"),tr("21.wav"));
   la2=new QLabel(tr("til Aalborg fredag"));
   dw2=new DictateWord(this,tr("eftermiddag"),tr("22.wav"));
   la3=new QLabel(tr(". Vi"));
   dw3=new DictateWord(this,tr("tjekkede"),tr("23.wav"));
   la4=new QLabel(tr("ind"));
   line1->addWidget(la1);
   line1->addWidget(dw1);
   line1->addWidget(la2);
   line1->addWidget(dw2);
   line1->addWidget(la3);
   line1->addWidget(dw3);
   line1->addWidget(la4);
   line1->addStretch();

   // Line 2:
   la5=new QLabel(tr("på"));
   dw4=new DictateWord(this,tr("hotellet"),tr("24.wav"));
   la6=new QLabel(tr("og gik ud på"));
   dw5=new DictateWord(this,tr("sightseeing"),tr("25.wav"));
   la7=new QLabel(tr(". Det"));
   dw6=new DictateWord(this,tr("første"),tr("26.wav"));
   la8=new QLabel(tr("vi så,"));
   line2->addWidget(la5);
   line2->addWidget(dw4);
   line2->addWidget(la6);
   line2->addWidget(dw5);
   line2->addWidget(la7);
   line2->addWidget(dw6);
   line2->addWidget(la8);
   line2->addStretch();

   // Line 3:
   la9=new QLabel(tr("var Jens Bangs stenhus. Det er en flot"));
   dw7=new DictateWord(this,tr("renæssancebygning"),tr("27.wav"));
   la10=new QLabel(tr("i fem"));
   dw8=new DictateWord(this,tr("etager"),tr("28.wav"));
   la11=new QLabel(tr("."));
   line3->addWidget(la9);
   line3->addWidget(dw7);
   line3->addWidget(la10);
   line3->addWidget(dw8);
   line3->addWidget(la11);
   line3->addStretch();

   // Line 4:
   la12=new QLabel(tr("Jens Bang var byens"));
   dw9=new DictateWord(this,tr("rigeste"),tr("29.wav"));
   la13=new QLabel(tr("købmand, da han i 1623"));
   dw10=new DictateWord(this,tr("byggede"),tr("30.wav"));
   line4->addWidget(la12);
   line4->addWidget(dw9);
   line4->addWidget(la13);
   line4->addWidget(dw10);
   line4->addStretch();

   // Line 5:
   la14=new QLabel(tr("huset."));
   line5->addWidget(la14);
   line5->addStretch();

   // Line 6:
   la15=new QLabel(tr("Jens Bangs stenhus var en stor"));
   dw11=new DictateWord(this,tr("provokation"),tr("31.wav"));
   la16=new QLabel(tr("for byens"));
   dw12=new DictateWord(this,tr("borgerskab"),tr("32.wav"));
   la17=new QLabel(tr(". Det"));
   line6->addWidget(la15);
   line6->addWidget(dw11);
   line6->addWidget(la16);
   line6->addWidget(dw12);
   line6->addWidget(la17);
   line6->addStretch();

   // Line 7:
   la18=new QLabel(tr("var"));
   dw13=new DictateWord(this,tr("nemlig"),tr("33.wav"));
   la19=new QLabel(tr("slet ikke"));
   dw14=new DictateWord(this,tr("tilladt"),tr("34.wav"));
   la20=new QLabel(tr("dengang, at almindelige"));
   line7->addWidget(la18);
   line7->addWidget(dw13);
   line7->addWidget(la19);
   line7->addWidget(dw14);
   line7->addWidget(la20);
   line7->addStretch();

   // Line 8:
   dw15=new DictateWord(this,tr("borgerlige"),tr("35.wav"));
   la21=new QLabel(tr(", som Jens Bang,"));
   dw16=new DictateWord(this,tr("konstruerede"),tr("36.wav"));
   la22=new QLabel(tr("så store huse - og så i sten!"));
   line8->addWidget(dw15);
   line8->addWidget(la21);
   line8->addWidget(dw16);
   line8->addWidget(la22);
   line8->addStretch();

   // Line 9:
   la23=new QLabel(tr("Men Jens Bang var gode"));
   dw17=new DictateWord(this,tr("venner"),tr("37.wav"));
   la24=new QLabel(tr("med den"));
   dw18=new DictateWord(this,tr("daværende"),tr("38.wav"));
   la25=new QLabel(tr("konge,"));
   line9->addWidget(la23);
   line9->addWidget(dw17);
   line9->addWidget(la24);
   line9->addWidget(dw18);
   line9->addWidget(la25);
   line9->addStretch();

   // Line 10:
   la26=new QLabel(tr("Christian den"));
   dw19=new DictateWord(this,tr("fjerde"),tr("39.wav"),false,false); // Both "fjerde" and "Fjerde" are okay
   la27=new QLabel(tr("."));
   line10->addWidget(la26);
   line10->addWidget(dw19);
   line10->addWidget(la27);
   line10->addStretch();

   // Line 11:
   la28=new QLabel(tr("Kongen havde"));
   dw20=new DictateWord(this,tr("bestandigt"),tr("40.wav"));
   la29=new QLabel(tr("brug for"));
   dw21=new DictateWord(this,tr("penge"),tr("41.wav"));
   la30=new QLabel(tr("til sine mange krige"));
   line11->addWidget(la28);
   line11->addWidget(dw20);
   line11->addWidget(la29);
   line11->addWidget(dw21);
   line11->addWidget(la30);
   line11->addStretch();

   // Line 12:
   la31=new QLabel(tr("mod"));
   dw22=new DictateWord(this,tr("svenskerne"),tr("42.wav"));
   la32=new QLabel(tr(". Jens Bang var"));
   dw23=new DictateWord(this,tr("flink"),tr("43.wav"));
   la33=new QLabel(tr("og lånte"));
   line12->addWidget(la31);
   line12->addWidget(dw22);
   line12->addWidget(la32);
   line12->addWidget(dw23);
   line12->addWidget(la33);
   line12->addStretch();

   // Line 13:
   dw24=new DictateWord(this,tr("gerne"),tr("44.wav"));
   la34=new QLabel(tr("ud af sin"));
   dw25=new DictateWord(this,tr("formue"),tr("45.wav"));
   la35=new QLabel(tr("til kongen. Som tak"));
   line13->addWidget(dw24);
   line13->addWidget(la34);
   line13->addWidget(dw25);
   line13->addWidget(la35);
   line13->addStretch();

   // Line 14:
   dw26=new DictateWord(this,tr("sendte"),tr("46.wav"));
   la36=new QLabel(tr("kongen en hollandsk"));
   dw27=new DictateWord(this,tr("arkitekt"),tr("47.wav"));
   la37=new QLabel(tr("til byen, som rejste det"));
   line14->addWidget(dw26);
   line14->addWidget(la36);
   line14->addWidget(dw27);
   line14->addWidget(la37);
   line14->addStretch();

   // Line 15:
   dw28=new DictateWord(this,tr("imponerende"),tr("48.wav"));
   la38=new QLabel(tr("hus."));
   line15->addWidget(dw28);
   line15->addWidget(la38);
   line15->addStretch();

   // Line 16:
   la39=new QLabel(tr("Da vi gik rundt om"));
   dw29=new DictateWord(this,tr("hjørnet"),tr("49.wav"));
   la40=new QLabel(tr("til husets"));
   dw30=new DictateWord(this,tr("sydgavl"),tr("50.wav"));
   la41=new QLabel(tr(", kunne vi se flere"));
   line16->addWidget(la39);
   line16->addWidget(dw29);
   line16->addWidget(la40);
   line16->addWidget(dw30);
   line16->addWidget(la41);
   line16->addStretch();

   // Line 17:
   la42=new QLabel(tr("af husets"));
   dw31=new DictateWord(this,tr("dekorationer"),tr("51.wav"));
   la43=new QLabel(tr(". De må have været en stor"));
   dw32=new DictateWord(this,tr("udfordring"),tr("52.wav"));
   la44=new QLabel(tr("for"));
   line17->addWidget(la42);
   line17->addWidget(dw31);
   line17->addWidget(la43);
   line17->addWidget(dw32);
   line17->addWidget(la44);
   line17->addStretch();

   // Line 18:
   la45=new QLabel(tr("aalborgenserne! Her kunne vi"));
   dw33=new DictateWord(this,tr("blandt"),tr("53.wav"));
   la46=new QLabel(tr("andet se en"));
   dw34=new DictateWord(this,tr("grotesk"),tr("54.wav"));
   line18->addWidget(la45);
   line18->addWidget(dw33);
   line18->addWidget(la46);
   line18->addWidget(dw34);
   line18->addStretch();

   // Line 19:
   la47=new QLabel(tr("figur, der rækker"));
   dw35=new DictateWord(this,tr("tunge"),tr("55.wav"));
   la48=new QLabel(tr("ad det gamle, gule rådhus, der"));
   line19->addWidget(la47);
   line19->addWidget(dw35);
   line19->addWidget(la48);
   line19->addStretch();

   // Line 20:
   dw36=new DictateWord(this,tr("ligger"),tr("56.wav"));
   la49=new QLabel(tr("lige overfor. Jens Bang ville på denne måde"));
   dw37=new DictateWord(this,tr("provokere"),tr("57.wav"));
   line20->addWidget(dw36);
   line20->addWidget(la49);
   line20->addWidget(dw37);
   line20->addStretch();

   // Line 21:
   la50=new QLabel(tr("de bysbørn, der aldrig havde"));
   dw38=new DictateWord(this,tr("accepteret"),tr("58.wav"));
   la51=new QLabel(tr("ham."));
   line21->addWidget(la50);
   line21->addWidget(dw38);
   line21->addWidget(la51);
   line21->addStretch();

   // Line 22:
   la52=new QLabel(tr("Jens Bang var"));
   dw39=new DictateWord(this,tr("kontroversiel"),tr("59.wav"));
   la53=new QLabel(tr("og"));
   dw40=new DictateWord(this,tr("excentrisk"),tr("60.wav"));
   la54=new QLabel(tr(", men også"));
   line22->addWidget(la52);
   line22->addWidget(dw39);
   line22->addWidget(la53);
   line22->addWidget(dw40);
   line22->addWidget(la54);
   line22->addStretch();

   // Line 23:
   dw41=new DictateWord(this,tr("spændende"),tr("61.wav"));
   la55=new QLabel(tr(", som hans"));
   dw42=new DictateWord(this,tr("bygningsværk"),tr("62.wav"));
   la56=new QLabel(tr("er det."));
   line23->addWidget(dw41);
   line23->addWidget(la55);
   line23->addWidget(dw42);
   line23->addWidget(la56);
   line23->addStretch();

   // Line 24:
   la57=new QLabel(tr("I"));
   dw43=new DictateWord(this,tr("kælderen"),tr("63.wav"));
   la58=new QLabel(tr("under Jens Bangs stenhus ligger »Duus Vinkælder«. Det er en"));
   line24->addWidget(la57);
   line24->addWidget(dw43);
   line24->addWidget(la58);
   line24->addStretch();

   // Line 25:
   la59=new QLabel(tr("fin, gammel"));
   dw44=new DictateWord(this,tr("restaurant"),tr("64.wav"));
   la60=new QLabel(tr(". Her har"));
   dw45=new DictateWord(this,tr("Danmarks"),tr("65.wav"));
   la61=new QLabel(tr("mest"));
   dw46=new DictateWord(this,tr("ansete"),tr("66.wav"));
   line25->addWidget(la59);
   line25->addWidget(dw44);
   line25->addWidget(la60);
   line25->addWidget(dw45);
   line25->addWidget(la61);
   line25->addWidget(dw46);
   line25->addStretch();

   // Line 26:
   la62=new QLabel(tr("selskab, Chr. IV's Laug,"));
   dw47=new DictateWord(this,tr("hjemme"),tr("67.wav"));
   la63=new QLabel(tr(". Da vi"));
   dw48=new DictateWord(this,tr("nærmede"),tr("68.wav"));
   la64=new QLabel(tr("os baren, så vi"));
   line26->addWidget(la62);
   line26->addWidget(dw47);
   line26->addWidget(la63);
   line26->addWidget(dw48);
   line26->addWidget(la64);
   line26->addStretch();

   // Line 27:
   dw49=new DictateWord(this,tr("straks"),tr("69.wav"));
   la65=new QLabel(tr("det store"));
   dw50=new DictateWord(this,tr("egetræsbord"),tr("70.wav"));
   la66=new QLabel(tr(". Når nye medlemmer bliver"));
   line27->addWidget(dw49);
   line27->addWidget(la65);
   line27->addWidget(dw50);
   line27->addWidget(la66);
   line27->addStretch();

   // Line 28:
   dw51=new DictateWord(this,tr("optaget"),tr("71.wav"));
   la67=new QLabel(tr(", sidder"));
   dw52=new DictateWord(this,tr("oldermanden"),tr("72.wav"));
   la68=new QLabel(tr(", i en"));
   dw53=new DictateWord(this,tr("dekorativ"),tr("73.wav"));
   la69=new QLabel(tr("stol, for"));
   line28->addWidget(dw51);
   line28->addWidget(la67);
   line28->addWidget(dw52);
   line28->addWidget(la68);
   line28->addWidget(dw53);
   line28->addWidget(la69);
   line28->addStretch();

   // Line 29:
   dw54=new DictateWord(this,tr("bordenden"),tr("74.wav"));
   la70=new QLabel(tr(". Laugsbrødrene sidder"));
   dw55=new DictateWord(this,tr("rundt"),tr("75.wav"));
   la71=new QLabel(tr("om det store bord til"));
   line29->addWidget(dw54);
   line29->addWidget(la70);
   line29->addWidget(dw55);
   line29->addWidget(la71);
   line29->addStretch();

   // Line 30:
   la72=new QLabel(tr("disse"));
   dw56=new DictateWord(this,tr("ceremonier"),tr("76.wav"));
   la73=new QLabel(tr(". De er"));
   dw57=new DictateWord(this,tr("elegante"),tr("77.wav"));
   la74=new QLabel(tr("at se på med deres røde kapper,"));
   line30->addWidget(la72);
   line30->addWidget(dw56);
   line30->addWidget(la73);
   line30->addWidget(dw57);
   line30->addWidget(la74);
   line30->addStretch();

   // Line 31:
   la75=new QLabel(tr("og"));
   dw58=new DictateWord(this,tr("arrangementet"),tr("78.wav"));
   la76=new QLabel(tr("er meget festligt og fornøjeligt."));
   line31->addWidget(la75);
   line31->addWidget(dw58);
   line31->addWidget(la76);
   line31->addStretch();

   // Line 32:
   la77=new QLabel(tr("I denne historiske kælder spiste vi"));
   dw59=new DictateWord(this,tr("burgere"),tr("79.wav"));
   la78=new QLabel(tr(", inden vi igen gik ud for at se"));
   line32->addWidget(la77);
   line32->addWidget(dw59);
   line32->addWidget(la78);
   line32->addStretch();

   // Line 33:
   la79=new QLabel(tr("på Aalborgs mange"));
   dw60=new DictateWord(this,tr("attraktioner"),tr("80.wav"));
   la80=new QLabel(tr("."));
   line33->addWidget(la79);
   line33->addWidget(dw60);
   line33->addWidget(la80);
   line33->addStretch();

   laLine1=new QLabel(tr("<html><hr></html>"));
   laClickArrow=new QLabel(tr("Når du mener, du er færdig, klikker du på den grønne pil."));
   laLine2=new QLabel(tr("<html><hr></html>"));

   dbNext=new DarkButton(this,tr("next.png"));
   loButtons->addStretch();
   loButtons->addWidget(dbNext);

   lo->addSpacing(20);
   lo->addWidget(laHeadLine);
   lo->addWidget(laTime);
   lo->addSpacing(20);
   lo->addLayout(line1);
   lo->addLayout(line2);
   lo->addLayout(line3);
   lo->addLayout(line4);
   lo->addLayout(line5);
   lo->addSpacing(20);
   lo->addLayout(line6);
   lo->addLayout(line7);
   lo->addLayout(line8);
   lo->addLayout(line9);
   lo->addLayout(line10);
   lo->addSpacing(20);
   lo->addLayout(line11);
   lo->addLayout(line12);
   lo->addLayout(line13);
   lo->addLayout(line14);
   lo->addLayout(line15);
   lo->addSpacing(20);
   lo->addLayout(line16);
   lo->addLayout(line17);
   lo->addLayout(line18);
   lo->addLayout(line19);
   lo->addLayout(line20);
   lo->addLayout(line21);
   lo->addSpacing(20);
   lo->addLayout(line22);
   lo->addLayout(line23);
   lo->addSpacing(20);
   lo->addLayout(line24);
   lo->addLayout(line25);
   lo->addLayout(line26);
   lo->addLayout(line27);
   lo->addLayout(line28);
   lo->addLayout(line29);
   lo->addLayout(line30);
   lo->addLayout(line31);
   lo->addSpacing(20);
   lo->addLayout(line32);
   lo->addLayout(line33);
   lo->addSpacing(20);
   lo->addWidget(laLine1);
   lo->addWidget(laClickArrow);
   lo->addWidget(laLine2);
   lo->addLayout(loButtons);
   lo->addStretch();
   setLayout(lo);

   // Handle returns:
   connect(dw1,SIGNAL(returnPressed()),dw2,SLOT(setFocus()));
   connect(dw2,SIGNAL(returnPressed()),dw3,SLOT(setFocus()));
   connect(dw3,SIGNAL(returnPressed()),dw4,SLOT(setFocus()));
   connect(dw4,SIGNAL(returnPressed()),dw5,SLOT(setFocus()));
   connect(dw5,SIGNAL(returnPressed()),dw6,SLOT(setFocus()));
   connect(dw6,SIGNAL(returnPressed()),dw7,SLOT(setFocus()));
   connect(dw7,SIGNAL(returnPressed()),dw8,SLOT(setFocus()));
   connect(dw8,SIGNAL(returnPressed()),dw9,SLOT(setFocus()));
   connect(dw9,SIGNAL(returnPressed()),dw10,SLOT(setFocus()));
   connect(dw10,SIGNAL(returnPressed()),dw11,SLOT(setFocus()));
   connect(dw11,SIGNAL(returnPressed()),dw12,SLOT(setFocus()));
   connect(dw12,SIGNAL(returnPressed()),dw13,SLOT(setFocus()));
   connect(dw13,SIGNAL(returnPressed()),dw14,SLOT(setFocus()));
   connect(dw14,SIGNAL(returnPressed()),dw15,SLOT(setFocus()));
   connect(dw15,SIGNAL(returnPressed()),dw16,SLOT(setFocus()));
   connect(dw16,SIGNAL(returnPressed()),dw17,SLOT(setFocus()));
   connect(dw17,SIGNAL(returnPressed()),dw18,SLOT(setFocus()));
   connect(dw18,SIGNAL(returnPressed()),dw19,SLOT(setFocus()));
   connect(dw19,SIGNAL(returnPressed()),dw20,SLOT(setFocus()));
   connect(dw20,SIGNAL(returnPressed()),dw21,SLOT(setFocus()));
   connect(dw21,SIGNAL(returnPressed()),dw22,SLOT(setFocus()));
   connect(dw22,SIGNAL(returnPressed()),dw23,SLOT(setFocus()));
   connect(dw23,SIGNAL(returnPressed()),dw24,SLOT(setFocus()));
   connect(dw24,SIGNAL(returnPressed()),dw25,SLOT(setFocus()));
   connect(dw25,SIGNAL(returnPressed()),dw26,SLOT(setFocus()));
   connect(dw26,SIGNAL(returnPressed()),dw27,SLOT(setFocus()));
   connect(dw27,SIGNAL(returnPressed()),dw28,SLOT(setFocus()));
   connect(dw28,SIGNAL(returnPressed()),dw29,SLOT(setFocus()));
   connect(dw29,SIGNAL(returnPressed()),dw30,SLOT(setFocus()));
   connect(dw30,SIGNAL(returnPressed()),dw31,SLOT(setFocus()));
   connect(dw31,SIGNAL(returnPressed()),dw32,SLOT(setFocus()));
   connect(dw32,SIGNAL(returnPressed()),dw33,SLOT(setFocus()));
   connect(dw33,SIGNAL(returnPressed()),dw34,SLOT(setFocus()));
   connect(dw34,SIGNAL(returnPressed()),dw35,SLOT(setFocus()));
   connect(dw35,SIGNAL(returnPressed()),dw36,SLOT(setFocus()));
   connect(dw36,SIGNAL(returnPressed()),dw37,SLOT(setFocus()));
   connect(dw37,SIGNAL(returnPressed()),dw38,SLOT(setFocus()));
   connect(dw38,SIGNAL(returnPressed()),dw39,SLOT(setFocus()));
   connect(dw39,SIGNAL(returnPressed()),dw40,SLOT(setFocus()));
   connect(dw40,SIGNAL(returnPressed()),dw41,SLOT(setFocus()));
   connect(dw41,SIGNAL(returnPressed()),dw42,SLOT(setFocus()));
   connect(dw42,SIGNAL(returnPressed()),dw43,SLOT(setFocus()));
   connect(dw43,SIGNAL(returnPressed()),dw44,SLOT(setFocus()));
   connect(dw44,SIGNAL(returnPressed()),dw45,SLOT(setFocus()));
   connect(dw45,SIGNAL(returnPressed()),dw46,SLOT(setFocus()));
   connect(dw46,SIGNAL(returnPressed()),dw47,SLOT(setFocus()));
   connect(dw47,SIGNAL(returnPressed()),dw48,SLOT(setFocus()));
   connect(dw48,SIGNAL(returnPressed()),dw49,SLOT(setFocus()));
   connect(dw49,SIGNAL(returnPressed()),dw50,SLOT(setFocus()));
   connect(dw50,SIGNAL(returnPressed()),dw51,SLOT(setFocus()));
   connect(dw51,SIGNAL(returnPressed()),dw52,SLOT(setFocus()));
   connect(dw52,SIGNAL(returnPressed()),dw53,SLOT(setFocus()));
   connect(dw53,SIGNAL(returnPressed()),dw54,SLOT(setFocus()));
   connect(dw54,SIGNAL(returnPressed()),dw55,SLOT(setFocus()));
   connect(dw55,SIGNAL(returnPressed()),dw56,SLOT(setFocus()));
   connect(dw56,SIGNAL(returnPressed()),dw57,SLOT(setFocus()));
   connect(dw57,SIGNAL(returnPressed()),dw58,SLOT(setFocus()));
   connect(dw58,SIGNAL(returnPressed()),dw59,SLOT(setFocus()));
   connect(dw59,SIGNAL(returnPressed()),dw60,SLOT(setFocus()));
   connect(dw60,SIGNAL(returnPressed()),dw1,SLOT(setFocus()));

   connect(dbNext,SIGNAL(clicked()),this,SLOT(slotNextPage()));
}

void Dictate2::saveInfo() {
   int nNNType1=0,nNNType2=0,nNNType3=0,nTotal,nTrin,nEndTime,nDuration,nHours,nMinuts,nSeconds;

   // Fetch time of ending the dictate:
   QDateTime dt;
   QTime time=dt.currentDateTime().time();
   nEndTime=3600*time.hour() + 60*time.minute() + time.second();
   nDuration=nEndTime-nBeginTime;
   nHours=nDuration/3600; // Not used for printout
   nDuration-=nHours*3600;
   nMinuts=nDuration/60;
   nDuration-=nMinuts*60;
   nSeconds=nDuration;

   QString sMinuts,sSeconds;
   QChar c('0');
   sMinuts=QString("%1").arg(nMinuts,2,10,c);
   sSeconds=QString("%1").arg(nSeconds,2,10,c);

   QFile file("results.html");
   if (!file.open(QIODevice::Append)) {
      QMessageBox::critical(this,tr("Kritisk fejl!"),tr("Programmet kan ikke skrive til\nfilen \"results.html\".\n\nKontakt din lærer!"),QMessageBox::Ok);
      exit(1);
   }
   QTextStream stream(&file);
   stream.setCodec("UTF-8");
   stream << "<h3>Diktat 2 [" << sMinuts << ":" << sSeconds << "]</h3>\n\n";
   stream << "<p>\n<small>\n<table border=\"1\" cols=\"3\" rows=\"22\">\n";

   stream << "<tr>\n";
   stream << tr("<td><b>Kontekstbetingede<br>stavemønstre</b></td>");
   stream << tr("<td><b>Etymologiske<br>stavemønstre</b></td>");
   stream << tr("<td><b>Morfologiske<br>stavemønstre</b></td>");
   stream << "\n</tr>\n";

   stream << "<tr>\n";
   stream << "<td>" + dw4->showAnswer(nNNType1) + "</td>"; // hotellet
   stream << "<td>" + dw3->showAnswer(nNNType2) + "</td>"; // tjekkede
   stream << "<td>" + dw1->showAnswer(nNNType3) + "</td>"; // ankom
   stream << "\n</tr>\n";

   stream << "<tr>\n";
   stream << "<td>" + dw13->showAnswer(nNNType1) + "</td>"; // nemlig
   stream << "<td>" + dw5->showAnswer(nNNType2) + "</td>"; // sightseeing
   stream << "<td>" + dw2->showAnswer(nNNType3) + "</td>"; // eftermiddag
   stream << "\n</tr>\n";

   stream << "<tr>\n";
   stream << "<td>" + dw14->showAnswer(nNNType1) + "</td>"; // tilladt
   stream << "<td>" + dw7->showAnswer(nNNType2) + "</td>"; // renæssancebygning
   stream << "<td>" + dw6->showAnswer(nNNType3) + "</td>"; // første
   stream << "\n</tr>\n";

   stream << "<tr>\n";
   stream << "<td>" + dw17->showAnswer(nNNType1) + "</td>"; // venner
   stream << "<td>" + dw8->showAnswer(nNNType2) + "</td>"; // etager
   stream << "<td>" + dw9->showAnswer(nNNType3) + "</td>"; // rigeste
   stream << "\n</tr>\n";

   stream << "<tr>\n";
   stream << "<td>" + dw19->showAnswer(nNNType1) + "</td>"; // Fjerde/fjerde
   stream << "<td>" + dw11->showAnswer(nNNType2) + "</td>"; // provokation
   stream << "<td>" + dw10->showAnswer(nNNType3) + "</td>"; // byggede
   stream << "\n</tr>\n";

   stream << "<tr>\n";
   stream << "<td>" + dw20->showAnswer(nNNType1) + "</td>"; // bestandigt
   stream << "<td>" + dw16->showAnswer(nNNType2) + "</td>"; // konstruerede
   stream << "<td>" + dw12->showAnswer(nNNType3) + "</td>"; // borgerskab
   stream << "\n</tr>\n";

   stream << "<tr>\n";
   stream << "<td>" + dw21->showAnswer(nNNType1) + "</td>"; // penge
   stream << "<td>" + dw27->showAnswer(nNNType2) + "</td>"; // arkitekt
   stream << "<td>" + dw15->showAnswer(nNNType3) + "</td>"; // borgerlige
   stream << "\n</tr>\n";

   stream << "<tr>\n";
   stream << "<td>" + dw23->showAnswer(nNNType1) + "</td>"; // flink
   stream << "<td>" + dw31->showAnswer(nNNType2) + "</td>"; // dekorationer
   stream << "<td>" + dw18->showAnswer(nNNType3) + "</td>"; // daværende
   stream << "\n</tr>\n";

   stream << "<tr>\n";
   stream << "<td>" + dw24->showAnswer(nNNType1) + "</td>"; // gerne
   stream << "<td>" + dw34->showAnswer(nNNType2) + "</td>"; // grotesk
   stream << "<td>" + dw22->showAnswer(nNNType3) + "</td>"; // svenskerne
   stream << "\n</tr>\n";

   stream << "<tr>\n";
   stream << "<td>" + dw25->showAnswer(nNNType1) + "</td>"; // formue
   stream << "<td>" + dw37->showAnswer(nNNType2) + "</td>"; // provokere
   stream << "<td>" + dw26->showAnswer(nNNType3) + "</td>"; // sendte
   stream << "\n</tr>\n";

   stream << "<tr>\n";
   stream << "<td>" + dw29->showAnswer(nNNType1) + "</td>"; // hjørnet
   stream << "<td>" + dw38->showAnswer(nNNType2) + "</td>"; // accepteret
   stream << "<td>" + dw28->showAnswer(nNNType3) + "</td>"; // imponerende
   stream << "\n</tr>\n";

   stream << "<tr>\n";
   stream << "<td>" + dw30->showAnswer(nNNType1) + "</td>"; // sydgavl
   stream << "<td>" + dw39->showAnswer(nNNType2) + "</td>"; // kontroversiel
   stream << "<td>" + dw32->showAnswer(nNNType3) + "</td>"; // udfordring
   stream << "\n</tr>\n";

   stream << "<tr>\n";
   stream << "<td>" + dw33->showAnswer(nNNType1) + "</td>"; // blandt
   stream << "<td>" + dw40->showAnswer(nNNType2) + "</td>"; // excentrisk
   stream << "<td>" + dw41->showAnswer(nNNType3) + "</td>"; // spændende
   stream << "\n</tr>\n";

   stream << "<tr>\n";
   stream << "<td>" + dw35->showAnswer(nNNType1) + "</td>"; // tunge
   stream << "<td>" + dw44->showAnswer(nNNType2) + "</td>"; // restaurant
   stream << "<td>" + dw42->showAnswer(nNNType3) + "</td>"; // bygningsværk
   stream << "\n</tr>\n";

   stream << "<tr>\n";
   stream << "<td>" + dw36->showAnswer(nNNType1) + "</td>"; // ligger
   stream << "<td>" + dw53->showAnswer(nNNType2) + "</td>"; // dekorativ
   stream << "<td>" + dw43->showAnswer(nNNType3) + "</td>"; // kælderen
   stream << "\n</tr>\n";

   stream << "<tr>\n";
   stream << "<td>" + dw45->showAnswer(nNNType1) + "</td>"; // Danmarks
   stream << "<td>" + dw56->showAnswer(nNNType2) + "</td>"; // ceremonier
   stream << "<td>" + dw46->showAnswer(nNNType3) + "</td>"; // ansete
   stream << "\n</tr>\n";

   stream << "<tr>\n";
   stream << "<td>" + dw49->showAnswer(nNNType1) + "</td>"; // straks
   stream << "<td>" + dw57->showAnswer(nNNType2) + "</td>"; // elegante
   stream << "<td>" + dw47->showAnswer(nNNType3) + "</td>"; // hjemme
   stream << "\n</tr>\n";

   stream << "<tr>\n";
   stream << "<td>" + dw52->showAnswer(nNNType1) + "</td>"; // oldermanden
   stream << "<td>" + dw58->showAnswer(nNNType2) + "</td>"; // arrangementet
   stream << "<td>" + dw48->showAnswer(nNNType3) + "</td>"; // nærmede
   stream << "\n</tr>\n";

   stream << "<tr>\n";
   stream << "<td>" + dw54->showAnswer(nNNType1) + "</td>"; // bordenden
   stream << "<td>" + dw59->showAnswer(nNNType2) + "</td>"; // burgere
   stream << "<td>" + dw50->showAnswer(nNNType3) + "</td>"; // egetræsbord
   stream << "\n</tr>\n";

   stream << "<tr>\n";
   stream << "<td>" + dw55->showAnswer(nNNType1) + "</td>"; // rundt
   stream << "<td>" + dw60->showAnswer(nNNType2) + "</td>"; // attraktioner
   stream << "<td>" + dw51->showAnswer(nNNType3) + "</td>"; // optaget
   stream << "\n</tr>\n";

   stream << "<tr>\n";
   stream << "<td><b>" << nNNType1 << "</b></td>"; // Total type 1
   stream << "<td><b>" << nNNType2 << "</b></td>"; // Total type 2
   stream << "<td><b>" << nNNType3 << "</b></td>"; // Total type 3
   stream << "\n</tr>\n</table>\n</small>\n\n<p>\n<small>\n";

   nTotal=nNNType1+nNNType2+nNNType3;
   stream << "<font color=\"blue\"><b>Total: " << nTotal << "</b></font><br>\n";
   if (nTotal>=51) nTrin=4;
   else if (nTotal>=38) nTrin=3;
   else if (nTotal>=22) nTrin=2;
   else nTrin=1;
   stream << "Trin " << nTrin << "\n</small>\n\n</body>\n</html>\n";

   stream.flush();
   file.close();
}

void Dictate2::slotNextPage() {
   g_voice.stopSound();
   if (!bHasTimedOut) {
      QMessageBox mb; // Danish yes/no question:
      QAbstractButton *noButton;
      mb.setWindowTitle(tr("Advarsel!"));
      mb.setIcon(QMessageBox::Warning);
      mb.setText(tr("Er du sikker på, at du er\nHELT færdig med Diktat 2?"));
      mb.addButton(tr("Ja"),QMessageBox::YesRole);
      noButton=mb.addButton(tr("Nej"),QMessageBox::NoRole);
      mb.exec();
      if (mb.clickedButton()==noButton) return;
   }
   saveInfo();
   emit nextPage(); // Send next-page-button clicked signal, grabbed by MainWindow.
}

void Dictate2::showEvent(QShowEvent* e) { // Set the initial focus to the first word
   activateWindow();
   dw1->setFocus();

   // Fetch time of beginning the dictate:
   QDateTime dt;
   QTime time=dt.currentDateTime().time();
   nBeginTime=3600*time.hour() + 60*time.minute() + time.second();

   QWidget::showEvent(e);
}

void Dictate2::makeGrey() {
   dw1->setEnabled(false);
   dw2->setEnabled(false);
   dw3->setEnabled(false);
   dw4->setEnabled(false);
   dw5->setEnabled(false);
   dw6->setEnabled(false);
   dw7->setEnabled(false);
   dw8->setEnabled(false);
   dw9->setEnabled(false);
   dw10->setEnabled(false);
   dw11->setEnabled(false);
   dw12->setEnabled(false);
   dw13->setEnabled(false);
   dw14->setEnabled(false);
   dw15->setEnabled(false);
   dw16->setEnabled(false);
   dw17->setEnabled(false);
   dw18->setEnabled(false);
   dw19->setEnabled(false);
   dw20->setEnabled(false);
   dw21->setEnabled(false);
   dw22->setEnabled(false);
   dw23->setEnabled(false);
   dw24->setEnabled(false);
   dw25->setEnabled(false);
   dw26->setEnabled(false);
   dw27->setEnabled(false);   dw28->setEnabled(false);
   dw29->setEnabled(false);
   dw30->setEnabled(false);
   dw31->setEnabled(false);
   dw32->setEnabled(false);
   dw33->setEnabled(false);
   dw34->setEnabled(false);
   dw35->setEnabled(false);
   dw36->setEnabled(false);
   dw37->setEnabled(false);
   dw38->setEnabled(false);
   dw39->setEnabled(false);
   dw40->setEnabled(false);
   dw41->setEnabled(false);
   dw42->setEnabled(false);
   dw43->setEnabled(false);
   dw44->setEnabled(false);
   dw45->setEnabled(false);
   dw46->setEnabled(false);
   dw47->setEnabled(false);
   dw48->setEnabled(false);
   dw49->setEnabled(false);
   dw50->setEnabled(false);
   dw51->setEnabled(false);
   dw52->setEnabled(false);
   dw53->setEnabled(false);
   dw54->setEnabled(false);
   dw55->setEnabled(false);
   dw56->setEnabled(false);
   dw57->setEnabled(false);
   dw58->setEnabled(false);
   dw59->setEnabled(false);
   dw60->setEnabled(false);
   bHasTimedOut=true; // So that we don't ask if the student really is sure he has finised
}
