#include <QScrollArea>
#include <QSound>

#include "Overview.h"
#include "Welcome.h"
#include "Info.h"
#include "Dictate1Help.h"
#include "Dictate1.h"
#include "Dictate2Help.h"
#include "Dictate2.h"
#include "Results.h"

class MainWindow : public QWidget {
   Q_OBJECT
private:
   int nCurrentPage;
   QScrollArea *scr;
   QPalette palette;
   QBrush brBackground;
   QHBoxLayout *layout;
   Overview *overview;
   Welcome *welcome;
   Info *info;
   Dictate1Help *help1;
   Dictate2Help *help2;
   Results *results;
   DarkMargin *right_margin;
private slots:
   void nextPage();
public:
   MainWindow();
};
