#include <QApplication>
#include <QTextCodec>

#include "Player.h"
#include "MainWindow.h"
#include "SplashDialog.h"

Player g_voice; // Global player used elsewhere

int main(int argc, char *argv[]) {
   QApplication app(argc,argv);
//   app.setStyle("Plastique"); // "Windows", "Cleanlooks", "Motif", "CDE". "Plastique" are other possibilities
   QTextCodec::setCodecForTr(QTextCodec::codecForName("UTF-8")); // Allows us to use Unicode in the source code
   SplashDialog sd;
   if (sd.exec()==QDialog::Accepted) {
      MainWindow mw;
      mw.showFullScreen();
      return app.exec();
   }
   return 0;
}
