#include <QLabel>
#include <QVBoxLayout>
#include <QTextBrowser>

#include "CenterFrame.h"
#include "DarkButton.h"

class Results : public CenterFrame {
   Q_OBJECT
private:
   QVBoxLayout *lo;
   QHBoxLayout *loButtons;
   QLabel *laHeadLine,*laPDF,*laPrint;
   QTextBrowser *tb;
   DarkButton *dbSaveAsPDF,*dbPrintResults;
private slots:
   void saveAsPDF();
   void printResults();
public:
   Results(QWidget *);
   void loadResults();
};
