#include <QTimer>
#include <QLabel>
#include <QProgressBar>
#include <QVBoxLayout>

class TimeLimiter : public QWidget {
Q_OBJECT
private:
   int nTimeOut,nMinsLeft,nDictate;
   QTimer *timer;
   QFont foNormal;
   QVBoxLayout *layout;
   QLabel *la;
   QProgressBar *pb;
private slots:
   void slotShowMinutsLeft();
signals:
   void timeOut();
public:
   TimeLimiter(QWidget *);
   void start(int,int);
   void stop();
};
